## libpano13 2.9.19+dfsg

=== CMakeLists.txt ===
## cmakelists.txt for libpano13 in a Hugin build environment.
##     03-04 Aug 2009 TKSharpless
##  Updated 16 Jan 2010 to add general Pannini projection
##
## For Windows, download just part of the panotools SVN tree:
## https://panotools.svn.sourceforge.net/svnroot/panotools/trunk/libpano
## into local directory libpano under the hugin SDK root.
## Then build in-place with CMake, and build INSTALL.  That
## will create a directory in the SDK root that the hugin
## CMake build scripts can use.
##    
## Builds libpano13 and selected panotools, by default without 
## support for the Java programs ptpicker and pteditor.  You
## can define SUPPORT_JAVA_PROGRAMS on the CMake command line; the script
## produces error if the Java header jni.h and its dependencies are not found.
##
## This script uses the Hugin CMake modules to find required
## image file format libraries, so it needs to know the name
## of the Hign source tree root.  By default that must be
## "../hugin" relative to the libpano root(that contains
## this file).  But you can set HUGIN_BASE_DIR to the path
## name of the Hugin root on the CMake command line.
##
## The parent directory of the Hugin root is one place where
## dependencies will be looked for.  On Windows that should
## be the root directory of the Hugin SDK, and the wxWidgets
## package will likely supply the dependencies.  Note:  you
## may need to edit the wxWidgets version number below.
##

# require at least cmake 2.8
cmake_minimum_required(VERSION 2.8)

#
# find dependencies
#
IF (UNIX)
  FIND_PACKAGE(PkgConfig)
ENDIF (UNIX)

## Locate the hugin source root and its parent directory
IF(HUGIN_BASE_DIR)
  GET_FILENAME_COMPONENT(SOURCE_BASE_DIR ${HUGIN_BASE_DIR} PATH CACHE)
  set(CMAKE_MODULE_PATH ${HUGIN_BASE_DIR}/CMakeModules)
ELSE(HUGIN_BASE_DIR)
  GET_FILENAME_COMPONENT(SOURCE_BASE_DIR ${CMAKE_SOURCE_DIR} PATH CACHE)
  set(CMAKE_MODULE_PATH ${SOURCE_BASE_DIR}/hugin/CMakeModules)
ENDIF(HUGIN_BASE_DIR)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}")

IF(WIN32)
  set(CMAKE_INSTALL_PREFIX "${SOURCE_BASE_DIR}/libpano13" CACHE PATH "Install prefix for libpano")
ENDIF(WIN32)

set(HUGIN_SHARED OFF)

include(CheckIncludeFiles)

##  global setup
project(libpano13)

set(MYLIB "lib")        # default
if(CMAKE_INSTALL_PREFIX STREQUAL "/usr")
  get_property(USE_64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
  if(USE_64)
    include(GNUInstallDirs)
    set(MYLIB ${CMAKE_INSTALL_LIBDIR})
  endif()
endif()

##
#  This must come before FINDs for tiff, jpeg, png, zlib to enable
#  finding the wxWidgets distributions of those packages on Windows.
IF(WIN32)
  ADD_DEFINITIONS(-D__Win__)
  OPTION(BUILD_DLL "Build dynamic libpano 13" OFF)
  OPTION(BUILD_WINGUI "Build with Windows GUI, otherwise the information is printed to shell/cmd.exe" OFF)
  set(win_c "tools/compat_win32/getopt.c")
  IF(BUILD_WINGUI)
    SET(sys_c "sys_win.c")
    SET(sys_h "sys_win.h")
  ELSE(BUILD_WINGUI)
    SET(sys_c "sys_ansi.c")
    SET(sys_h "sys_ansi.h")
  ENDIF(BUILD_WINGUI)
  SET(sys_compat_c "sys_compat_win.c")
ELSE(WIN32)
  ##
  ## Cleaner Debian Packaging (enable by -DDISABLE_DPKG=OFF)
  ##

  SET(sys_c "sys_ansi.c")
  SET(sys_h "sys_ansi.h")
  SET(sys_compat_c "sys_compat_unix.c")
ENDIF(WIN32)

OPTION(SUPPORT_JAVA_PROGRAMS "Set this to support for the Java programs ptpicker and pteditor" OFF)
if(SUPPORT_JAVA_PROGRAMS)
  find_package(Java REQUIRED)
  find_package(JNI REQUIRED)
  include_directories(${JAVA_INCLUDE_PATH} ${JAVA_INCLUDE_PATH2})
endif()

##
## Graphics libraries
##
# wxWidgets sub-packages will be used if native ones aren't found

FIND_PACKAGE(TIFF REQUIRED)
INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
FIND_PACKAGE(JPEG REQUIRED)
INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
FIND_PACKAGE(PNG REQUIRED)
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})

set(_common_libs ${TIFF_LIBRARIES} ${ZLIB_LIBRARIES} ${JPEG_LIBRARIES} ${PNG_LIBRARIES})

#
# Check build type and set options accordingly
#
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)
IF(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
  ADD_DEFINITIONS(-DDEBUG)
  IF(UNIX)
    ADD_DEFINITIONS(-Wall)
  ENDIF(UNIX)
ENDIF(${CMAKE_BUILD_TYPE} STREQUAL "Debug")

IF(UNIX)
  ADD_DEFINITIONS(-D__Ansi__)
ELSE(UNIX)
  IF(MSVC)
    # Stop MSVC8 from bitching about the C library
    ADD_DEFINITIONS(/D_CRT_SECURE_NO_DEPRECATE)
    # Stop MSVC9 from bitching about possibly invalid STL usage
    ADD_DEFINITIONS(/D_SCL_SECURE_NO_WARNINGS)
    # Stop MSVC9 from bitching about POSIX names without underscores
    ADD_DEFINITIONS(/D_CRT_NONSTDC_NO_DEPRECATE)
    IF(NOT BUILD_WINGUI)
      ADD_DEFINITIONS(/D__Ansi__)
    ENDIF()
    IF(NOT BUILD_DLL)
      # compile everything for the static C runtime
		FOREACH(TYPE C CXX)
			# makefiles use blank configuration
			FOREACH(CFG "_DEBUG" "_MINSIZEREL" "_RELEASE" "_RELWITHDEBINFO")
				#MESSAGE("Replacing CMAKE_${TYPE}_FLAGS${CFG}: ${CMAKE_${TYPE}_FLAGS${CFG}}")
				SET(NEW_FLAGS "${CMAKE_${TYPE}_FLAGS${CFG}}")
				# fix up static libc flags
				STRING(REPLACE "/MD" "/MT" NEW_FLAGS "${NEW_FLAGS}")
				# *FORCE* to override whats already placed into the cache
				SET(CMAKE_${TYPE}_FLAGS${CFG} "${NEW_FLAGS}" CACHE STRING
					"CMAKE_${TYPE}_FLAGS${CFG} (overwritten to ensure static build)" FORCE)
				#MESSAGE("New       CMAKE_${TYPE}_FLAGS${CFG}: ${CMAKE_${TYPE}_FLAGS${CFG}}")
			ENDFOREACH(CFG)
		ENDFOREACH(TYPE)
	    # link only with the static C runtime !! THIS IS A MUST !!
		SET(NEW_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
		# ensure that the flags are not duplicaated on subsequent runs
		STRING(REPLACE " /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\"" "" NEW_FLAGS "${NEW_FLAGS}")
		# note that flag names(NODEFAULTLIB) etc.) are case sensitive
    	SET(CMAKE_EXE_LINKER_FLAGS
        	"${NEW_FLAGS} /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\""
	       CACHE STRING "for MSVC" FORCE
		)
	ENDIF(NOT BUILD_DLL)
  ENDIF(MSVC)
  IF(MINGW)
    IF(NOT BUILD_WINGUI)
      ADD_DEFINITIONS(/D__Ansi__)
    ENDIF()
  ENDIF(MINGW)
ENDIF(UNIX)

##
## Here is the part that builds libpano
##
if(SUPPORT_JAVA_PROGRAMS)
  set(java_h pteditor.h ptutils.h)
  set(java_c ptpicker.c pteditor.c)
else()
  set(java_c javastub.c)
endif(SUPPORT_JAVA_PROGRAMS)

set(pano13_install_hdr
  panorama.h
  filter.h
  version.h
  panotypes.h
  PTcommon.h
  pt_stdint.h
  file.h
  queryfeature.h
  pteditor.h
  ptutils.h)

set(pano13_hdr
	${java_h}
	${pano13_install_hdr}
	ColourBrightness.h
	f2c.h
	fftn.h
	rgbe.h
        sys_compat.h
	${sys_h}
	ZComb.h
	PaniniGeneral.h
)

set(pano13_res
	pano13.rc
)

set(pano13_src
	${java_c}
	${win_c}
	adjust.c
	bmp.c
	ColourBrightness.c
	correct.c
        dump.c
	fftn.c
	file.c
	filter.c
	fourier.c
	hdrfile.c
	jpeg.c
	jpegicc.c
	lmdif.c
	math.c
	metadata.c
	morpher.c
	multilayer.c
	optimize.c
	pan.c
	parser.c
	perspect.c
	png.c
	ppm.c
	PTcommon.c
	PTDialogs.c
	ptfeather.c
	ptstitch.c
	queryfeature.c
	remap.c
	resample.c
	rgbe.c
	seamer.c
	${sys_c}
	${sys_compat_c}
	sys_common.c
	tiff.c
	Triangulate.c
	ZComb.c
	PaniniGeneral.c
)
# We have some header files at top source level now
include_directories(${CMAKE_SOURCE_DIR})

if(NOT WIN32)
  # Create and install shared library on non-windows
  add_library(pano13 SHARED ${pano13_hdr} ${pano13_res} ${pano13_src})
  target_link_libraries(pano13 ${_common_libs})
  set_target_properties(pano13 PROPERTIES VERSION "3.0.0" SOVERSION "3")
  install(TARGETS pano13 LIBRARY DESTINATION ${MYLIB} COMPONENT libraries)
  set(_pano_target pano13)
  #create and install static library
  add_library(pano13a STATIC ${pano13_hdr} ${pano13_res} ${pano13_src})
  set_target_properties(pano13a PROPERTIES OUTPUT_NAME pano13)
  install(TARGETS pano13a ARCHIVE DESTINATION ${MYLIB} COMPONENT libraries)
else()
  IF(BUILD_DLL)
    # Create and install shared library
    ADD_DEFINITIONS(-DPANO13_DLL)
    add_library(pano13 SHARED ${pano13_hdr} ${pano13_res} ${pano13_src})
    target_link_libraries(pano13 ${_common_libs})
    set_target_properties(pano13 PROPERTIES VERSION "3.0.0" SOVERSION "3")
    IF(MINGW)
      set_target_properties(pano13 PROPERTIES PREFIX "")
    ENDIF()
    install(TARGETS pano13 RUNTIME DESTINATION bin ARCHIVE DESTINATION lib LIBRARY DESTINATION lib COMPONENT libraries)
  ELSE(BUILD_DLL)
    #create and install static library
    add_library(pano13 STATIC ${pano13_hdr} ${pano13_res} ${pano13_src})
    install(TARGETS pano13 ARCHIVE DESTINATION ${MYLIB} COMPONENT libraries)
  ENDIF(BUILD_DLL)
  set(_pano_target pano13)
endif()

IF( CMAKE_SIZEOF_VOID_P EQUAL 8 AND MSVC )
	# Error detected with generator Visual Studio 10 Win64
	# > LINK : warning LNK4068: /MACHINE not specified; defaulting to X86
	# > fatal error LNK1112: module machine type 'x64' conflicts with target machine type 'X86'
	#
	# There is no default value for static libraries and cmake isn't setting it either.
	# We fix this by adding the flag manually.
	IF(NOT BUILD_DLL)
		SET_TARGET_PROPERTIES(pano13 PROPERTIES STATIC_LIBRARY_FLAGS \"/machine:x64\")
	ENDIF()
ENDIF()

install(FILES ${pano13_install_hdr} DESTINATION "include/pano13" COMPONENT headers)

# install documentation expected by hugin install script
INSTALL(
  FILES
	AUTHORS
	COPYING
	README
  DESTINATION "share/pano13/doc"
  COMPONENT headers
        )
INSTALL(
  FILES
        doc/Optimize.txt
        doc/PTblender.readme
        doc/PTmender.readme
        doc/stitch.txt
  DESTINATION "share/pano13/doc"
  COMPONENT doc
        )

set(TOP_SRC_DIR ${CMAKE_SOURCE_DIR})

add_subdirectory(man)
add_dependencies(${_pano_target} man)
add_subdirectory(tools)
add_dependencies(tools ${_pano_target})

macro(setstripped _varname _value)
  string(STRIP ${_value} _v)
  if(USE_POSIX_PACKAGING)
    string(TOLOWER ${_v} ${_varname})
  else()
    set(${_varname} ${_v})
  endif()
endmacro(setstripped)

file(STRINGS "${TOP_SRC_DIR}/configure.ac" _config_lines)
foreach(_c_l ${_config_lines})
  if(_c_l MATCHES "^AC_INIT\\(\\[\([^,]+\)\\], *\\[\([^,]+\)\\], *\([^,]+\)")
    setstripped(PACKAGE_BASE ${CMAKE_MATCH_1})
    setstripped(PACKAGE_VERSION ${CMAKE_MATCH_2})
    setstripped(PACKAGE_BUGREPORT ${CMAKE_MATCH_3})
    if(PACKAGE_VERSION MATCHES "^\([0-9]+\)\\.\([0-9]+\)\\.\([0-9]+\).*$")
      message(STATUS "found version = ${PACKAGE_VERSION}")
      set(PANO_MAJOR_VERSION ${CMAKE_MATCH_1})
      set(PANO_MINOR_VERSION ${CMAKE_MATCH_2})
      set(PANO_PATCH_VERSION ${CMAKE_MATCH_3})
    endif()
  endif()
endforeach(_c_l)

# create TAGS file
ADD_CUSTOM_COMMAND( OUTPUT ctags POST_BUILD
                   COMMAND ctags-exuberant -e *.c *.h tools/*.c
                   WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/
                   COMMENT "Build TAGS file"
                 )
ADD_CUSTOM_TARGET( TAGS DEPENDS ctags)


# set some variables which are used in libpano13.pc.in
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(includedir ${CMAKE_INSTALL_PREFIX}/include)
set(LIB_JPEG ${JPEG_LIBRARY})
set(LIB_TIFF ${TIFF_LIBRARY})
set(LIB_ZLIB ${ZLIB_LIBRARY})
set(LIB_PNG ${PNG_LIBRARY})
set(VERSION ${PACKAGE_VERSION})
configure_file("${TOP_SRC_DIR}/libpano13.pc.in" "${CMAKE_BINARY_DIR}/libpano13.pc" @ONLY)
install(FILES "${CMAKE_BINARY_DIR}/libpano13.pc" DESTINATION "${MYLIB}/pkgconfig" COMPONENT libraries)

set(CPACK_PACKAGE_VERSION_MAJOR "${PANO_MAJOR_VERSION}")
set(CPACK_PACKAGE_VERSION_MINOR "${PANO_MINOR_VERSION}")
set(CPACK_PACKAGE_VERSION_PATCH "${PANO_PATCH_VERSION}")
set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

set(CPACK_SOURCE_IGNORE_FILES
"/BUILD/"
"~$"
"\\\\.swp$"
"\\\\.history$"
"\\\\.orig$"
"\\\\.#"
"\\\\.hg/"
"\\\\.hgignore$"
"\\\\.hgeol$"
"\\\\.hgtags$"
"\\\\.cvsignore$"
)

# needed by rpm
set(CPACK_SET_DESTDIR "ON")

# the next ones are needed by deb
set(CPACK_PACKAGE_CONTACT "${PACKAGE_BUGREPORT}")

=== man/CMakeLists.txt ===
# This file is part of libpano13, the hugin build environment.
# Licence details can be found in the file COPYING.
#
# Copyright (c) 2009 Kornel Benko, <Kornel.Benko@berlin.de>
#

project(man)

file(GLOB_RECURSE manuals RELATIVE "${TOP_SRC_DIR}/man" "${TOP_SRC_DIR}/man/*.1")

macro(add_manual _mansrc)
  get_filename_component(_mandest ${_mansrc} NAME_WE)
  SET(_created_manual "${CMAKE_CURRENT_BINARY_DIR}/${_mandest}.1")
  configure_file("${TOP_SRC_DIR}/man/${_mansrc}" ${_created_manual} @ONLY)
  SET_SOURCE_FILES_PROPERTIES(${_created_manual} GENERATED)
  LIST(APPEND _manuals ${_created_manual})
endmacro(add_manual)

set(_manuals)
foreach(_m ${manuals})
  # this is not needed now, but maybe we will later
  # adapt data like version or date into the manuals
  add_manual(${_m})
endforeach(_m)

add_custom_target(man ALL DEPENDS ${_manuals})

install(FILES ${_manuals} DESTINATION "share/man/man1" COMPONENT doc)

=== tests/CMakeLists.txt ===
# This file is part of libpano13, the hugin build environment.
# Licence details can be found in the file COPYING.
#
# Copyright (c) 2009 Kornel Benko, <Kornel.Benko@berlin.de>
#

project(test)

macro(prepare_test _testname _prjname _imagemask)
  file(GLOB images  RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/${_imagemask}")
  file(GLOB references  RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/reference/*")
  set(_depends)
  foreach(_i ${images} ${references})
    if(NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${_i}")
      add_custom_command(
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${_i}"
        COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/${_i}" "${CMAKE_CURRENT_BINARY_DIR}/${_i}"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${_i}")
      SET_SOURCE_FILES_PROPERTIES("${CMAKE_CURRENT_BINARY_DIR}/${_i}" GENERATED)
      list(APPEND _depends "${CMAKE_CURRENT_BINARY_DIR}/${_i}")
    endif()
  endforeach(_i)
  add_custom_target(${_prjname} ALL DEPENDS ${_depends})

  add_test(${_testname} ${PERL_EXECUTABLE} "${TOP_SRC_DIR}/tests/panoAutomateTest.pl" "${CMAKE_CURRENT_SOURCE_DIR}/simple.txt")
  add_dependencies(${_prjname} tools)
endmacro()

find_package(Perl)
if(PERL_FOUND)
    add_subdirectory(simpleStitch)
    add_subdirectory(simpleTiff16)
    add_subdirectory(simpleTiff2psd)
endif()

=== debian/changelog ===
libpano13 (2.9.19+dfsg-3ubuntu0.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: use of externally-controlled format string in PTcrop's
    output filename generation
    - debian/patches/CVE-2021-20307/*: Updates the help page, and checks the
      output prefix to not have "%" characters.
    - CVE-2021-20307
  * SECURITY UPDATE: invalid pointer dereferencing
    - debian/patches/CVE-2021-33293.patch: Checks the result of a strchr to
      not be NULL, avoiding a further dereferencing of an invalid pointer.
    - CVE-2021-33293

 -- George-Andrei Iosif <andrei.iosif@canonical.com>  Mon, 12 Jun 2023 16:19:14 +0300

libpano13 (2.9.19+dfsg-3) unstable; urgency=medium

  * Move Vcs-* from git/http to https.
  * Build with hardening=+all.
  * For get-orig-source use /usr/share/dpkg/pkg-info.mk instead of parsing
    dpkg-parsechangelog output.
  * Use debhelper v10 mode:
    + Uses autoreconf by default, drop -with autotools_dev and the respective
      b-d.
    + Drop 10_workaround_libtool_link_as_needed_bug and pass option
      --as-needed to dh_autoreconf instead.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 10 Sep 2017 14:39:18 +0200

libpano13 (2.9.19+dfsg-2) unstable; urgency=medium

  * B-d on libpng-dev instead of libpng12-dev. Closes: #662407

 -- Andreas Metzler <ametzler@debian.org>  Wed, 06 Jan 2016 17:45:05 +0100

libpano13 (2.9.19+dfsg-1) unstable; urgency=medium

  * New upstream stable release, identical to rc1.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 07 Jun 2014 13:38:05 +0200

libpano13 (2.9.19~rc1+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 10 May 2014 13:28:13 +0200

libpano13 (2.9.19~rc1+dfsg-1) experimental; urgency=medium

  * Fix get-orig-source to handle rc/beta tarballs and switch over to xz
    compression.
  * New Upstream version.
    + Unfuzz 10_workaround_libtool_link_as_needed_bug.
    + Drop 20_initfilenameargs.diff.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 24 Apr 2014 20:11:31 +0200

libpano13 (2.9.19~beta1+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 22 Feb 2014 15:22:54 +0100

libpano13 (2.9.19~beta1+dfsg-1) experimental; urgency=low

  * New upstream version.
  * Soname bumped, change runtime library package name.
  * Point vcs-* to anonscm.
  * Drop superfluous Breaks/Replaces with buggy libpano13-1 in PPA.
  * Build depend on libtiff-dev instead of libtiff4-dev.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 21 Dec 2013 14:49:54 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CFLAGS_MAINT_APPEND := -Wall
export DEB_CXXFLAGS_MAINT_APPEND := -Wall
export DEB_LDFLAGS_MAINT_APPEND := -Wl,-z,defs -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/pkg-info.mk

# For the repack: package name, mangled upstream version, non-free files
UVERNODFSG = $(subst +dfsg,,$(DEB_VERSION_UPSTREAM))


override_dh_auto_configure:
	dh_auto_configure --verbose -- \
		--enable-shared --enable-static \
		--with-jpeg --with-png --with-tiff \
		--with-zlib --without-java LIBS="-lm"

#override_dh_makeshlibs:
#	dh_makeshlibs -V 'libpano13-3 (>=2.9.18)'

override_dh_auto_install:
	dh_auto_install --verbose
	# Clear the rpath set on some architectures (e.g. amd64)
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/* \
		$(CURDIR)/debian/tmp/usr/lib/*/*.so
	rm -vf $(CURDIR)/debian/tmp/usr/lib/*/*.la

override_dh_install:
	dh_install --fail-missing

override_dh_autoreconf:
	dh_autoreconf --as-needed

# Build the DFSG-free source tarball
get-orig-source:
	# Download
	uscan --force-download --rename

	# Extract and prune non-free files
	tar xf ../$(DEB_SOURCE)_$(UVERNODFSG).orig.tar.gz
	# Rename, clean and repack.
	mv -v $$(tar tf ../$(DEB_SOURCE)_$(UVERNODFSG).orig.tar.gz | head -n1) \
		$(DEB_SOURCE)-$(UVERNODFSG).orig
	find $(DEB_SOURCE)-$(UVERNODFSG).orig \
		\( -name '*.rc' -or -name '*.vcproj' \
		-or -name '*.sln' -or -name '*.vsprops' -or \
		-name '*.vcxproj' \) -type f -delete
	tar cJf ../$(DEB_SOURCE)_$(UVERNODFSG)+dfsg.orig.tar.xz \
		$(DEB_SOURCE)-$(UVERNODFSG).orig
	rm -rf $(DEB_SOURCE)-$(UVERNODFSG).orig

%:
	dh $@

## libpano13 2.9.20~rc2+dfsg

=== debian/changelog ===
libpano13 (2.9.20~rc2+dfsg-2) experimental; urgency=low

  * Run "wrap-and-sort --max-line-length=72 --short-indent".
  * Use DEP-5 copyright.
  * Update watchfile, drop get-orig-source target.
  * Use dh 12 compat.
  * Add symbol file.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 21 Jul 2019 14:09:58 +0200

libpano13 (2.9.20~rc2+dfsg-1) experimental; urgency=low

  * Set Rules-Requires-Root: no.
  * New upstream version.
  * 20_typo_fixes.diff: Fix two typos found by lintian.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 23 Sep 2018 11:33:55 +0200

libpano13 (2.9.20~rc1+dfsg-1) experimental; urgency=low

  * New upstream version.
    + Also accepts *.jpeg as valid filename. Closes: #501237
  * [lintian] Fix trailing whitespace in debian/changelog.
  * Point Vcs* to salsa.
  * Use dh_missing.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 25 Mar 2018 19:16:48 +0200

=== debian/control ===
Source: libpano13
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Andreas Metzler <ametzler@debian.org>
Build-Depends:
 chrpath,
 debhelper-compat (= 12),
 libjpeg-dev,
 libpng-dev,
 libtiff-dev,
 libtiff-tools
Standards-Version: 4.4.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/libpano
Vcs-Git: https://salsa.debian.org/debian-phototools-team/libpano.git -b libpano13/unstable
Homepage: http://panotools.sourceforge.net/

Package: libpano13-dev
Section: libdevel
Architecture: any
Depends: libpano13-3 (= ${binary:Version}), ${misc:Depends}
Description: panorama tools library development files
 This package contains the panoramatools library. It provides basic
 algorithmic tools to generate, edit and transform many kinds of
 panoramic images.
 .
 This package holds static libraries and headers needed by developers
 who wish to use libpano13 in their programs.

Package: libpano13-3
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: libpano13-bin
Multi-Arch: same
Description: panorama tools library
 This package contains the panoramatools library. It provides basic
 algorithmic tools to generate, edit and transform many kinds of
 panoramic images.

Package: libpano13-bin
Section: graphics
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libpano12-bin
Replaces: libpano12-bin
Multi-Arch: foreign
Description: panorama tools utilities
 This package contains the following tools, all part of the Panorama Tools
 library, and supposed to make it easy to work with panoramic images:
  * panoinfo    - List details about the libpano13 library
  * PTblender   - Colour and brightness correction of panoramas
  * PTcrop      - Crop TIFF images
  * PTinfo      - Display information about a panotools-generated image
  * PTmasker    - Compute stitching masks
  * PTmender    - Replacement for PTStitcher
  * PToptimizer - Wrapper around control point optimization routines
  * PTroller    - Merge several images into a single one
  * PTtiff2psd  - Convert a set of TIFF files into a Photoshop PSD file
  * PTtiffdump  - Compare two TIFF images
  * PTuncrop    - Uncrop TIFF images

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CFLAGS_MAINT_APPEND := -Wall
export DEB_CXXFLAGS_MAINT_APPEND := -Wall
export DEB_LDFLAGS_MAINT_APPEND := -Wl,-z,defs -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/pkg-info.mk

# For the repack: package name, mangled upstream version, non-free files
UVERNODFSG = $(subst +dfsg,,$(DEB_VERSION_UPSTREAM))


override_dh_auto_configure:
	dh_auto_configure --verbose -- \
		--enable-shared --enable-static \
		--with-jpeg --with-png --with-tiff \
		--with-zlib --without-java LIBS="-lm"

override_dh_auto_install:
	dh_auto_install --verbose
	# Clear the rpath set on some architectures (e.g. amd64)
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/* \
		$(CURDIR)/debian/tmp/usr/lib/*/*.so
	rm -vf $(CURDIR)/debian/tmp/usr/lib/*/*.la

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

override_dh_missing:
	dh_missing --fail-missing

override_dh_autoreconf:
	dh_autoreconf --as-needed

%:
	dh $@

## libpano13 2.9.20~rc3%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -26,9 +26,6 @@
 override_dh_makeshlibs:
 	dh_makeshlibs -- -c4
 
-override_dh_missing:
-	dh_missing --fail-missing
-
 override_dh_autoreconf:
 	dh_autoreconf --as-needed

## libpano13 2.9.20~rc3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -52,7 +52,7 @@
   set(CMAKE_INSTALL_PREFIX "${SOURCE_BASE_DIR}/libpano13" CACHE PATH "Install prefix for libpano")
 ENDIF(WIN32)
 
-set(HUGIN_SHARED OFF)
+SET(CMAKE_DEBUG_POSTFIX d)
 
 include(CheckIncludeFiles)
 
@@ -73,9 +73,11 @@
 #  finding the wxWidgets distributions of those packages on Windows.
 IF(WIN32)
   ADD_DEFINITIONS(-D__Win__)
-  OPTION(BUILD_DLL "Build dynamic libpano 13" OFF)
+  OPTION(BUILD_DLL "Build dynamic libpano 13" ON)
   OPTION(BUILD_WINGUI "Build with Windows GUI, otherwise the information is printed to shell/cmd.exe" OFF)
-  set(win_c "tools/compat_win32/getopt.c")
+  IF(MSVC)
+    set(win_c "tools/compat_win32/getopt.c")
+  ENDIF()
   IF(BUILD_WINGUI)
     SET(sys_c "sys_win.c")
     SET(sys_h "sys_win.h")
@@ -400,4 +402,3 @@
 set(CPACK_SET_DESTDIR "ON")
 
 # the next ones are needed by deb
-set(CPACK_PACKAGE_CONTACT "${PACKAGE_BUGREPORT}")

=== tools/CMakeLists.txt ===
# This file is part of libpano13, the hugin build environment.
# Licence details can be found in the file COPYING.
#
# Copyright (c) 2009 Kornel Benko, <Kornel.Benko@berlin.de>
#

project(tools)

set(commands PTtiff2psd PTtiffdump PTcrop PTblender
    PTroller PTuncrop PToptimizer PTmender PTinfo PTmasker)
if (SUPPORT_JAVA_PROGRAMS)
  # this one depends on java (uses writeProject() from ptpicker)
  list(APPEND commands PTAInterpolate)
endif()

# panoinfo needs windows.h

set(extra_commands)
macro(make_command exe_name source_name)
  list(APPEND extra_commands ${exe_name})
  add_executable(${exe_name} ${source_name})
  target_link_libraries(${exe_name} ${_pano_target} ${_common_libs})
  install(TARGETS ${exe_name} DESTINATION bin COMPONENT tools CONFIGURATIONS Release RelWithDebInfo MinSizeRel)
endmacro()

if(WIN32)
  list(APPEND commands panoinfo)
  IF(BUILD_DLL)
    add_library(getopt STATIC compat_win32/getopt.c compat_win32/getopt.h)
    list(APPEND _common_libs getopt)
  ENDIF(BUILD_DLL)
else()
  make_command(panoinfo panoinfo_unix.c)
endif()

include_directories(${TOP_SRC_DIR})

foreach(_cmd ${commands})
  make_command(${_cmd} ${_cmd}.c)
endforeach(_cmd)

add_custom_target(tools DEPENDS ${extra_commands})

=== debian/changelog ===
libpano13 (2.9.20~rc3+dfsg-1) unstable; urgency=high

  * New upstream version.
    + Drop cherrypicked patches.
    + Fixes format string bug. Closes: #985249

 -- Andreas Metzler <ametzler@debian.org>  Wed, 17 Mar 2021 17:30:22 +0100

libpano13 (2.9.20~rc2+dfsg-3) unstable; urgency=low

  * Update to upstream HG tip.
    + Replace 20_typo_fixes.diff with
      1_845_Fixes_2_typos__Patch_by_Andreas_Metzler_.diff.
  * Upload to unstable.
  * Use dh v13 compat mode.
    + Drop superfluous dh_missing override.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 13 Dec 2020 13:25:42 +0100

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,12 @@
 Uploaders: Andreas Metzler <ametzler@debian.org>
 Build-Depends:
  chrpath,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libjpeg-dev,
  libpng-dev,
  libtiff-dev,
  libtiff-tools
-Standards-Version: 4.4.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/libpano
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/libpano.git -b libpano13/unstable

## libpano13 2.9.21+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,9 +28,11 @@
 ## may need to edit the wxWidgets version number below.
 ##
 
-# require at least cmake 2.8
-cmake_minimum_required(VERSION 2.8)
-
+# require at least cmake 3.0
+cmake_minimum_required(VERSION 3.0)
+if(POLICY CMP0074)
+  cmake_policy(SET CMP0074 NEW)
+endif()
 #
 # find dependencies
 #
@@ -47,6 +49,7 @@
   set(CMAKE_MODULE_PATH ${SOURCE_BASE_DIR}/hugin/CMakeModules)
 ENDIF(HUGIN_BASE_DIR)
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}")
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
 
 IF(WIN32)
   set(CMAKE_INSTALL_PREFIX "${SOURCE_BASE_DIR}/libpano13" CACHE PATH "Install prefix for libpano")
@@ -59,14 +62,8 @@
 ##  global setup
 project(libpano13)
 
-set(MYLIB "lib")        # default
-if(CMAKE_INSTALL_PREFIX STREQUAL "/usr")
-  get_property(USE_64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
-  if(USE_64)
-    include(GNUInstallDirs)
-    set(MYLIB ${CMAKE_INSTALL_LIBDIR})
-  endif()
-endif()
+# support lib/lib64
+include(GNUInstallDirs)
 
 ##
 #  This must come before FINDs for tiff, jpeg, png, zlib to enable
@@ -117,6 +114,20 @@
 INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
 
 set(_common_libs ${TIFF_LIBRARIES} ${ZLIB_LIBRARIES} ${JPEG_LIBRARIES} ${PNG_LIBRARIES})
+
+include(CheckLibraryExists)
+# Does explicit linking against libm work?
+check_library_exists(m exp "" LIBMNEEDED)
+if(LIBMNEEDED)
+  list(APPEND _common_libs "m")
+endif()
+
+# Sparse or dense Levenberg Marquardt
+OPTION(USE_SPARSE_LEVMAR "Use Sparse Levenberg Marquardt algorithm instead of dense Levenberg Marquardt algorithm" OFF)
+IF(USE_SPARSE_LEVMAR)
+  FIND_PACKAGE(SUITESPARSE REQUIRED)
+  LIST(APPEND _common_libs ${SUITESPARSE_LIBRARIES})
+ENDIF()
 
 #
 # Check build type and set options accordingly
@@ -233,7 +244,6 @@
 	hdrfile.c
 	jpeg.c
 	jpegicc.c
-	lmdif.c
 	math.c
 	metadata.c
 	morpher.c
@@ -264,17 +274,26 @@
 # We have some header files at top source level now
 include_directories(${CMAKE_SOURCE_DIR})
 
+IF(USE_SPARSE_LEVMAR)
+  LIST(APPEND pano13_hdr levmar.h)
+  LIST(APPEND pano13_src levmar.c)
+  ADD_DEFINITIONS(-DUSE_SPARSE_LEVENBERG_MARQUARDT)
+  INCLUDE_DIRECTORIES(${SUITESPARSE_INCLUDE_DIRS})
+ELSE()
+  LIST(APPEND pano13_src lmdif.c)
+ENDIF()
+
 if(NOT WIN32)
   # Create and install shared library on non-windows
-  add_library(pano13 SHARED ${pano13_hdr} ${pano13_res} ${pano13_src})
+  add_library(pano13 SHARED ${pano13_hdr} ${pano13_src})
   target_link_libraries(pano13 ${_common_libs})
   set_target_properties(pano13 PROPERTIES VERSION "3.0.0" SOVERSION "3")
-  install(TARGETS pano13 LIBRARY DESTINATION ${MYLIB} COMPONENT libraries)
+  install(TARGETS pano13 LIBRARY COMPONENT libraries)
   set(_pano_target pano13)
   #create and install static library
-  add_library(pano13a STATIC ${pano13_hdr} ${pano13_res} ${pano13_src})
+  add_library(pano13a STATIC ${pano13_hdr} ${pano13_src})
   set_target_properties(pano13a PROPERTIES OUTPUT_NAME pano13)
-  install(TARGETS pano13a ARCHIVE DESTINATION ${MYLIB} COMPONENT libraries)
+  install(TARGETS pano13a ARCHIVE COMPONENT libraries)
 else()
   IF(BUILD_DLL)
     # Create and install shared library
@@ -285,11 +304,11 @@
     IF(MINGW)
       set_target_properties(pano13 PROPERTIES PREFIX "")
     ENDIF()
-    install(TARGETS pano13 RUNTIME DESTINATION bin ARCHIVE DESTINATION lib LIBRARY DESTINATION lib COMPONENT libraries)
+    install(TARGETS pano13 COMPONENT libraries)
   ELSE(BUILD_DLL)
     #create and install static library
     add_library(pano13 STATIC ${pano13_hdr} ${pano13_res} ${pano13_src})
-    install(TARGETS pano13 ARCHIVE DESTINATION ${MYLIB} COMPONENT libraries)
+    install(TARGETS pano13 COMPONENT libraries)
   ENDIF(BUILD_DLL)
   set(_pano_target pano13)
 endif()
@@ -329,8 +348,6 @@
 
 set(TOP_SRC_DIR ${CMAKE_SOURCE_DIR})
 
-add_subdirectory(man)
-add_dependencies(${_pano_target} man)
 add_subdirectory(tools)
 add_dependencies(tools ${_pano_target})
 
@@ -343,13 +360,11 @@
   endif()
 endmacro(setstripped)
 
-file(STRINGS "${TOP_SRC_DIR}/configure.ac" _config_lines)
+file(STRINGS "${TOP_SRC_DIR}/version.h" _config_lines)
 foreach(_c_l ${_config_lines})
-  if(_c_l MATCHES "^AC_INIT\\(\\[\([^,]+\)\\], *\\[\([^,]+\)\\], *\([^,]+\)")
-    setstripped(PACKAGE_BASE ${CMAKE_MATCH_1})
-    setstripped(PACKAGE_VERSION ${CMAKE_MATCH_2})
-    setstripped(PACKAGE_BUGREPORT ${CMAKE_MATCH_3})
-    if(PACKAGE_VERSION MATCHES "^\([0-9]+\)\\.\([0-9]+\)\\.\([0-9]+\).*$")
+  if(_c_l MATCHES "^.define PTVERSION_FILEVERSIONNUMBER \([0-9]+,[0-9]+,[0-9]+\)")
+    setstripped(PACKAGE_VERSION ${CMAKE_MATCH_1})
+    if(PACKAGE_VERSION MATCHES "^\([0-9]+\),\([0-9]+\),\([0-9]+\)")
       message(STATUS "found version = ${PACKAGE_VERSION}")
       set(PANO_MAJOR_VERSION ${CMAKE_MATCH_1})
       set(PANO_MINOR_VERSION ${CMAKE_MATCH_2})
@@ -358,6 +373,16 @@
   endif()
 endforeach(_c_l)
 
+set(PACKAGE_BASE "pano13")
+set(PACKAGE_VERSION ${PANO_MAJOR_VERSION}.${PANO_MINOR_VERSION}.${PANO_PATCH_VERSION})
+set(PACKAGE_BUGREPORT "https://bugs.launchpad.net/panotools")
+
+# man pages need the version string
+if(NOT WIN32)
+add_subdirectory(man)
+add_dependencies(${_pano_target} man)
+endif()
+
 # create TAGS file
 ADD_CUSTOM_COMMAND( OUTPUT ctags POST_BUILD
                    COMMAND ctags-exuberant -e *.c *.h tools/*.c
@@ -371,34 +396,12 @@
 set(prefix ${CMAKE_INSTALL_PREFIX})
 set(exec_prefix ${CMAKE_INSTALL_PREFIX})
 set(includedir ${CMAKE_INSTALL_PREFIX}/include)
+if(DEFINED CMAKE_INSTALL_LIBDIR)
+  set(libdir "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
+else()
+  set(libdir "${CMAKE_INSTALL_PREFIX}/lib")
+endif()
 set(LIB_JPEG ${JPEG_LIBRARY})
 set(LIB_TIFF ${TIFF_LIBRARY})
 set(LIB_ZLIB ${ZLIB_LIBRARY})
 set(LIB_PNG ${PNG_LIBRARY})
-set(VERSION ${PACKAGE_VERSION})
-configure_file("${TOP_SRC_DIR}/libpano13.pc.in" "${CMAKE_BINARY_DIR}/libpano13.pc" @ONLY)
-install(FILES "${CMAKE_BINARY_DIR}/libpano13.pc" DESTINATION "${MYLIB}/pkgconfig" COMPONENT libraries)
-
-set(CPACK_PACKAGE_VERSION_MAJOR "${PANO_MAJOR_VERSION}")
-set(CPACK_PACKAGE_VERSION_MINOR "${PANO_MINOR_VERSION}")
-set(CPACK_PACKAGE_VERSION_PATCH "${PANO_PATCH_VERSION}")
-set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
-
-set(CPACK_SOURCE_IGNORE_FILES
-"/BUILD/"
-"~$"
-"\\\\.swp$"
-"\\\\.history$"
-"\\\\.orig$"
-"\\\\.#"
-"\\\\.hg/"
-"\\\\.hgignore$"
-"\\\\.hgeol$"
-"\\\\.hgtags$"
-"\\\\.cvsignore$"
-)
-
-# needed by rpm
-set(CPACK_SET_DESTDIR "ON")
-
-# the next ones are needed by deb

=== man/Makefile ===
# FIXME this needs to be integrated with CMake
#
PACKAGE='LIBPANO13 TOOLS'
PACKAGE_VERSION=2.9.21

man : panoinfo.1 PTAInterpolate.1 PTblender.1 PTcrop.1 PTinfo.1 PTmasker.1 PTmender.1 PToptimizer.1 PTroller.1 PTtiff2psd.1 PTtiffdump.1 PTuncrop.1

%.1: %.pod
	pod2man --center $(PACKAGE) --release $(PACKAGE_VERSION) $< $@

=== tests/simpleTiff2psd/CMakeLists.txt ===
# This file is part of libpano13, the hugin build environment.
# Licence details can be found in the file gpl.txt.
#
# Copyright (c) 2009 Kornel Benko, <Kornel.Benko@berlin.de>
#

SET (TIFFc0 ../simpleStitch/reference/tiff_m0000.tif)
SET (TIFFc1 ../simpleStitch/reference/tiff_m0001.tif)

SET (TIFFu0 ../simpleStitch/reference/tiff_m_uncropped0000.tif)
SET (TIFFu1 ../simpleStitch/reference/tiff_m_uncropped0001.tif)

SET (TIFF16 ../simpleTiff16/reference/tiff_m0000.tif)

project(test3)

file(GLOB references  RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/reference/*.psd")
set(_depends)
foreach(_i ${references})
  if(NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${_i}")
    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${_i}"
      COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/${_i}" "${CMAKE_CURRENT_BINARY_DIR}/${_i}"
      DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${_i}")
    SET_SOURCE_FILES_PROPERTIES("${CMAKE_CURRENT_BINARY_DIR}/${_i}" GENERATED)
    list(APPEND _depends "${CMAKE_CURRENT_BINARY_DIR}/${_i}")
  endif()
endforeach(_i)
add_custom_target(test3 ALL DEPENDS ${_depends})

add_test(simpleTiff2psd-1-layer ${PERL_EXECUTABLE} "${TOP_SRC_DIR}/tests/panoAutomatePSDtest.pl" simpleStitch_crop_1_layer.psd ${TIFFc0})
add_test(simpleTiff2psd-2-layers ${PERL_EXECUTABLE} "${TOP_SRC_DIR}/tests/panoAutomatePSDtest.pl" simpleStitch_crop_2_layer.psd ${TIFFc0} ${TIFFc1})

add_test(simpleTiff2psd-1-layer-uncropped ${PERL_EXECUTABLE} "${TOP_SRC_DIR}/tests/panoAutomatePSDtest.pl" simpleStitch_uncrop_1_layer.psd ${TIFFu0})
add_test(simpleTiff2psd-2-layers-uncropped ${PERL_EXECUTABLE} "${TOP_SRC_DIR}/tests/panoAutomatePSDtest.pl" simpleStitch_uncrop_2_layer.psd ${TIFFu0} ${TIFFu1})

add_test(simpleTiff16-16bit-1-layer ${PERL_EXECUTABLE} "${TOP_SRC_DIR}/tests/panoAutomatePSDtest.pl" 
         simpleTiff16-16-_uncrop_1_layer.psd ${TIFF16})

add_test(simpleTiff16-16bit-2-layers ${PERL_EXECUTABLE} "${TOP_SRC_DIR}/tests/panoAutomatePSDtest.pl" 
         simpleTiff16-16-_uncrop_2_layer.psd ${TIFF16} ${TIFF16})

=== debian/changelog ===
libpano13 (2.9.21+dfsg-3) unstable; urgency=medium

  [ Debian Janitor ]
  *  Apply multi-arch hints:
     + libpano13-dev: Add Multi-Arch: same.

  [ Andreas Metzler ]
  * 917_da06997f4c2f_Include__arpa_inet_h__if_it_is_available__for_the_htons_function_macro.diff
    from upstream HG: C99 compatibility fix by Florian Weimer.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 22 Jan 2023 08:03:47 +0100

libpano13 (2.9.21+dfsg-2) unstable; urgency=high

  * Upload to unstable.
  * Add CVE-reference to previous changelog entry.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 21 Mar 2022 18:24:48 +0100

libpano13 (2.9.21+dfsg-1) experimental; urgency=medium

  * Run wrap-and-sort -ast.
  * New upstream version, fixes CVE-2021-33293.

 -- Andreas Metzler <ametzler@debian.org>  Fri, 31 Dec 2021 13:03:37 +0100

libpano13 (2.9.21~rc2+dfsg-1) experimental; urgency=medium

  * New upstream version.
   + Drop patches. (All were pulled from upstream HG)

 -- Andreas Metzler <ametzler@debian.org>  Sat, 04 Dec 2021 16:24:48 +0100

libpano13 (2.9.21~rc1+dfsg-2) experimental; urgency=medium

  * 10_8_84b6a82c8afc_Fix_for_bigendian_architectures__Thomas_Modes_.diff
    fixes testsuite error on big endian.
  * 20_pkgconfig_multiarch.diff applied upstream, renamed.
  * 10_7_4d12cc78cc80_Fix_support_for_lib_lib64_installation_dirs.diff - Use
    include(GNUInstallDirs)

 -- Andreas Metzler <ametzler@debian.org>  Wed, 03 Nov 2021 18:18:39 +0100

libpano13 (2.9.21~rc1+dfsg-1) experimental; urgency=low

  * New upstream version.
    + autoconf build system was dropped, switch to cmake build. (Add b-d,
      update dh_auto_configure override, drop dh_autoreconf override.)
    + Install additional documentation, list uninstalled files to make
      dh_missing happy.
    + Update symbol file.
    + Build fixes from upstream HG:
      10_1_af97aa936771_Fixes_generation_of_libpano13_pc_file.diff
      10_2_343847e37b1f_Remove_Windows_rc_files_from_file_list_for_Unix.diff
      10_3_2822f00918bc_Install_tools_in_all_configurations.diff
      10_4_b6aef04b6318_Let_CMake_for_itself_figure_out_the_lib_directory.diff
      10_5_1b0e1a205121_Check_if_linking_against_libm_is_needed.diff.
    + 20_pkgconfig_multiarch.diff Fix pkg-config file contents and location.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 30 Oct 2021 13:53:00 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,17 @@
 Section: libs
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
-Uploaders: Andreas Metzler <ametzler@debian.org>
+Uploaders:
+ Andreas Metzler <ametzler@debian.org>,
 Build-Depends:
  chrpath,
+ cmake,
  debhelper-compat (= 13),
  libjpeg-dev,
  libpng-dev,
  libtiff-dev,
- libtiff-tools
-Standards-Version: 4.5.1
+ libtiff-tools,
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/libpano
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/libpano.git -b libpano13/unstable
@@ -19,7 +21,10 @@
 Package: libpano13-dev
 Section: libdevel
 Architecture: any
-Depends: libpano13-3 (= ${binary:Version}), ${misc:Depends}
+Depends:
+ libpano13-3 (= ${binary:Version}),
+ ${misc:Depends},
+Multi-Arch: same
 Description: panorama tools library development files
  This package contains the panoramatools library. It provides basic
  algorithmic tools to generate, edit and transform many kinds of
@@ -30,9 +35,13 @@
 
 Package: libpano13-3
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Pre-Depends: ${misc:Pre-Depends}
-Suggests: libpano13-bin
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Pre-Depends:
+ ${misc:Pre-Depends},
+Suggests:
+ libpano13-bin,
 Multi-Arch: same
 Description: panorama tools library
  This package contains the panoramatools library. It provides basic
@@ -42,9 +51,13 @@
 Package: libpano13-bin
 Section: graphics
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Conflicts: libpano12-bin
-Replaces: libpano12-bin
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Conflicts:
+ libpano12-bin,
+Replaces:
+ libpano12-bin,
 Multi-Arch: foreign
 Description: panorama tools utilities
  This package contains the following tools, all part of the Panorama Tools

## libpano13 2.9.22~rc2+dfsg

=== debian/changelog ===
libpano13 (2.9.22~rc2+dfsg-1) unstable; urgency=low

  * New upstream version.
    + Drop cherry-picked patch.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 12 Aug 2023 18:19:02 +0200

## libpano13 2.9.22+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -206,7 +206,6 @@
   version.h
   panotypes.h
   PTcommon.h
-  pt_stdint.h
   file.h
   queryfeature.h
   pteditor.h

=== debian/changelog ===
libpano13 (2.9.22+dfsg-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:54:44 +0000

libpano13 (2.9.22+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062564

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 16:14:34 +0000

libpano13 (2.9.22+dfsg-1) unstable; urgency=medium

  * Drop Apple's "XCode" IDE file PanoTools.pbproj.tgz from tarball.
  * New upstrea, identical to rc2.

 -- Andreas Metzler <ametzler@debian.org>  Wed, 20 Sep 2023 11:19:28 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: libpano13
 Section: libs
 Priority: optional
-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders:
  Andreas Metzler <ametzler@debian.org>,
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
  chrpath,
  cmake,
  debhelper-compat (= 13),
@@ -22,7 +23,7 @@
 Section: libdevel
 Architecture: any
 Depends:
- libpano13-3 (= ${binary:Version}),
+ libpano13-3t64 (= ${binary:Version}),
  ${misc:Depends},
 Multi-Arch: same
 Description: panorama tools library development files
@@ -33,7 +34,10 @@
  This package holds static libraries and headers needed by developers
  who wish to use libpano13 in their programs.
 
-Package: libpano13-3
+Package: libpano13-3t64
+Provides: ${t64:Provides}
+Replaces: libpano13-3
+Breaks: libpano13-3 (<< ${source:Version})
 Architecture: any
 Depends:
  ${misc:Depends},

## libpano13 2.9.23~rc1+dfsg

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
   list(APPEND extra_commands ${exe_name})
   add_executable(${exe_name} ${source_name})
   target_link_libraries(${exe_name} ${_pano_target} ${_common_libs})
-  install(TARGETS ${exe_name} DESTINATION bin COMPONENT tools CONFIGURATIONS Release RelWithDebInfo MinSizeRel)
+  install(TARGETS ${exe_name} DESTINATION bin COMPONENT tools)
 endmacro()
 
 if(WIN32)

=== debian/changelog ===
libpano13 (2.9.23~rc1+dfsg-1) experimental; urgency=medium

  * New upstream version.
  * Drop all patches.
  * Copy updated GPL licence grant to debian/copyright.
  * Two unused symbols were dropped upstream, update symbol file.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 06 Oct 2025 18:18:09 +0200

libpano13 (2.9.22+dfsg-4) unstable; urgency=medium

  * Bump cmake compat to >= 3.5. (Closes: #1113183)
  * Run wrap-and-sort -ast
  * Bump Standards-Version

 -- Andreas Metzler <ametzler@debian.org>  Sat, 06 Sep 2025 13:11:21 +0200

libpano13 (2.9.22+dfsg-3) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 10 Aug 2025 16:34:10 +0200

libpano13 (2.9.22+dfsg-2) experimental; urgency=medium

  * Cherry-pick patches from upstream HG and
    https://bugs.launchpad.net/panotools/+bug/2096612 to fix ftbfs with
    GCC-15. Closes: #1097246

 -- Andreas Metzler <ametzler@debian.org>  Sun, 20 Jul 2025 13:36:24 +0200

## libpano13 2.9.23%2Bdfsg

=== man/CMakeLists.txt ===
# This file is part of libpano13, the hugin build environment.
# Licence details can be found in the file COPYING.
#
# Copyright (c) 2009 Kornel Benko, <Kornel.Benko@berlin.de>
#

project(man)

FIND_PROGRAM(POD2MAN pod2man REQUIRED)
IF(NOT POD2MAN)
  MESSAGE(FATAL_ERROR "Pod2man not found, but needed to create man pages")
ENDIF()
file(GLOB manuals "*.pod")

macro(add_manual _mansrc)
  get_filename_component(_mandest ${_mansrc} NAME_WE)
  SET(_created_manual "${CMAKE_CURRENT_BINARY_DIR}/${_mandest}.1")
  ADD_CUSTOM_COMMAND(
        OUTPUT "${_created_manual}"
        COMMAND ${POD2MAN} "--center=LIBPANO13 TOOLS" "--release=Version: ${PACKAGE_VERSION}" "${_mansrc}" "${_created_manual}"
        DEPENDS "${_mansrc}"
        VERBATIM
  )
  SET_SOURCE_FILES_PROPERTIES(${_created_manual} GENERATED)
  LIST(APPEND _manuals ${_created_manual})
endmacro(add_manual)

set(_manuals)
foreach(_m ${manuals})
  add_manual(${_m})
endforeach(_m)

add_custom_target(man ALL DEPENDS ${_manuals})

install(FILES ${_manuals} DESTINATION "share/man/man1" COMPONENT doc)

=== debian/changelog ===
libpano13 (2.9.23+dfsg-1) unstable; urgency=low

  * New upstream version, identical to rc1.
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 25 Oct 2025 13:52:04 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: libpano13
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders:
  Andreas Metzler <ametzler@debian.org>,
-Build-Depends: dpkg-dev (>= 1.22.5),
+Build-Depends:
+ debhelper-compat (= 13),
+ dpkg-dev (>= 1.22.5),
  chrpath,
- cmake,
- debhelper-compat (= 13),
+ cmake (>= 3.5),
  libjpeg-dev,
  libpng-dev,
  libtiff-dev,
  libtiff-tools,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/libpano
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/libpano.git -b libpano13/unstable
@@ -35,9 +35,12 @@
  who wish to use libpano13 in their programs.
 
 Package: libpano13-3t64
-Provides: ${t64:Provides}
-Replaces: libpano13-3
-Breaks: libpano13-3 (<< ${source:Version})
+Provides:
+ ${t64:Provides},
+Replaces:
+ libpano13-3,
+Breaks:
+ libpano13-3 (<< ${source:Version}),
 Architecture: any
 Depends:
  ${misc:Depends},
